
/*
 * File Helper.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __API_Helper__
#define __API_Helper__

namespace Lib
{
template<typename T> class VirtualIterator;
template<class C> class Stack;

class OptionsReader;
}

namespace Kernel
{
class Formula;
class FormulaUnit;
class TermList;
class Unit;
class Literal;
}

namespace Api {


class Problem;

class DefaultHelperCore;
class FBHelperCore;
class FormulaBuilder;
class StringIterator;

class ApiHelper
{
public:
  ApiHelper();
  ~ApiHelper();
  ApiHelper(const ApiHelper& h);
  ApiHelper& operator=(const ApiHelper& h);
  ApiHelper& operator=(FBHelperCore* hc);
  bool operator==(const ApiHelper& h) const;
  bool operator!=(const ApiHelper& h) const;

  DefaultHelperCore* operator->() const;
  DefaultHelperCore* operator*() const;
protected:
  void updRef(bool inc);

  FBHelperCore* _obj;
};

class FBHelper
: public ApiHelper
{
public:
  FBHelper();
  FBHelperCore* operator->() const;
};

}

#endif 
