
/*
 * File ClausifierDependencyFix.cpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */



#include "Forwards.hpp"

#include "Lib/Exception.hpp"

#include "Kernel/LiteralSelector.hpp"

#include "Saturation/SaturationAlgorithm.hpp"
#include "Shell/AnswerExtractor.hpp"
#include "Shell/InterpolantMinimizer.hpp"

void LiteralSelector::reversePredicatePolarity(unsigned pred, bool reverse)
{
}

void Saturation::SaturationAlgorithm::tryUpdateFinalClauseCount()
{
}

Shell::InterpolantMinimizer::InterpolantMinimizer(OptimizationTarget, bool, bool, string)
{
}
Shell::InterpolantMinimizer::~InterpolantMinimizer()
{
}
Kernel::Formula* Shell::InterpolantMinimizer::getInterpolant(Kernel::Unit*)
{
  INVALID_OPERATION("not supported in clausifier");
}

void AnswerExtractor::tryOutputAnswer(Clause* refutation)
{
  INVALID_OPERATION("not supported in clausifier");
}

AnswerLiteralManager* AnswerLiteralManager::getInstance()
{
  INVALID_OPERATION("answer literals not supported in clausifier");
}

bool AnswerLiteralManager::addAnswerLiterals(UnitList*& units)
{
  INVALID_OPERATION("answer literals not supported in clausifier");
}
void AnswerLiteralManager::addAnswerLiterals(Problem& prb)
{
  INVALID_OPERATION("answer literals not supported in clausifier");
}
