
/*
 * File DecisionProcedure.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __DecisionProcedure__
#define __DecisionProcedure__

#include "Forwards.hpp"

#include "Kernel/Term.hpp"



namespace DP {

using namespace Lib;
using namespace Kernel;

class DecisionProcedure {
public:
  enum Status {
    SATISFIABLE,
    UNSATISFIABLE,
   
    UNKNOWN
  };

  virtual ~DecisionProcedure() {}

  virtual void addLiterals(LiteralIterator lits) = 0;

  virtual Status getStatus(bool getMultipleCores=false) = 0;

 
  virtual unsigned getUnsatCoreCount() = 0;
  virtual void getUnsatCore(LiteralStack& res, unsigned coreIndex=0) = 0;

 
  virtual void reset() = 0;
};

class ScopedDecisionProcedure : public DecisionProcedure {
public:
  virtual void push() = 0;
  virtual void pop(unsigned scopeCount) = 0;
};

}

#endif 
