
/*
 * File Log_TagDecls.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __Log_TagDecls__
#define __Log_TagDecls__

#include "Log.hpp"

#if LOGGING

#define DECL(name,...) \
  do {								\
    const char* t = name;					\
    Debug::Logging::declareTag(t);				\
    __VA_ARGS__;						\
  } while(false)
#define DOC(doc) Debug::Logging::addDoc(t,doc)
#define PARENT(parent, depth) Debug::Logging::addParent(t,parent,depth)
#define UNIT_TAG Debug::Logging::markUnitTag(t)
#define INT_TAG Debug::Logging::markIntTag(t)

#endif

#endif 
