
/*
 * File ArithmeticIndex.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __ArithmeticIndex__
#define __ArithmeticIndex__

#include "Forwards.hpp"

#include "Lib/DHMap.hpp"

#include "Kernel/Theory.hpp"

#include "Kernel/Algebra/ArithmeticKB.hpp"

#include "Index.hpp"

namespace Indexing {

#if 0

using namespace Lib;
using namespace Kernel;
using namespace Kernel::Algebra;

class ConstraintDatabase
: public ArithmeticKB
{
public:
  ConstraintDatabase();

  void handleLiteral(Literal* lit, bool adding, Clause* premise, bool negative=false);

  
  bool isNonEqual(TermList t, InterpretedType val, Clause*& premise);
  
  bool isGreater(TermList t, InterpretedType val, Clause*& premise);
  
  bool isLess(TermList t, InterpretedType val, Clause*& premise);

  void reset()
  { _termConstraints.reset(); }

private:
  
  struct ConstraintInfo;
  
  Theory* theory;
  DHMap<TermList, ConstraintInfo*> _termConstraints;
};


class ArithmeticIndex
: public Index
{
public:
  ArithmeticIndex();

  void handleClause(Clause* c, bool adding);

  bool isNonEqual(TermList t, InterpretedType val, Clause*& premise)
  { return _db.isNonEqual(t, val, premise); }
  bool isGreater(TermList t, InterpretedType val, Clause*& premise)
  { return _db.isGreater(t, val, premise); }
  bool isLess(TermList t, InterpretedType val, Clause*& premise)
  { return _db.isLess(t, val, premise); }


private:
  ConstraintDatabase _db;
};
#endif
}

#endif 
