
/*
 * File ClauseSharing.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __ClauseSharing__
#define __ClauseSharing__

#include "Forwards.hpp"

#include "ClauseVariantIndex.hpp"

namespace Indexing
{

using namespace Kernel;
using namespace Saturation;

class ClauseSharing
{
public:
  enum InsertionResult {
    INSERTED,
    OLD_MODIFIED,
    OLD,
    ALREADY_THERE
  };

  void init(SaturationAlgorithm* sa);

  bool doSharing(Clause* cl);

  Clause* insert(Clause* c, InsertionResult& res);
  void insertNew(Clause* c);
  Clause* tryGet(Literal* const * lits, unsigned len);
  Clause* tryGet(Clause* c);
private:
  ClauseVariantIndex _index;

  SaturationAlgorithm* _sa;
};

};

#endif
