
/*
 * File Constraint.cpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#include "Kernel/Theory.hpp"

#include "Constraint.hpp"

namespace Kernel
{
namespace Algebra
{
#if 0
bool Constraint::isConstraint(Literal* lit)
{
  CALL("Constraint::isConstraint");

  return lit->isEquality() || theory->isInterpretedPredicate(lit, Theory::LESS_EQUAL) ||
      theory->isInterpretedPredicate(lit, Theory::INT_LESS_EQUAL);
}

Constraint::Constraint(Literal* lit, bool negate)
: _simplified(false)
{
  CALL("Constraint::Constraint");
  ASS(isConstraint(lit));

  _inequality=!lit->isEquality();
  _negative=lit->isNegative();
  _integer=theory->isInterpretedPredicate(lit, Theory::INT_LESS_EQUAL);

  TermList t1=*lit->nthArgument(0);
  TermList t2=*lit->nthArgument(1);

  bool swapSign=_negative;

  if(t1==theory->zero()) {
    swap(t1,t2);
    swapSign^=1;
  }
  _pol.init(t1);
  if(t2!=theory->zero()) {
    Polynomial pol2(t2);
    _pol.subtract(pol2);
  }

  _simplified|=_pol.mergeSummands();
  _simplified|=_pol.reduceCoeffitients();

  if(_inequality && swapSign) {
    if(!_pol.negate()) {
      
      TermList neg=TermList(theory->fun1(Theory::UNARY_MINUS, _pol.toTerm()));
      _pol.reset();
      _pol.init(neg);
    }
  }
}

bool Constraint::simplify()
{
  CALL("Constraint::simplify");

  if(doSimplifications()) {
    _simplified=true;
    return true;
  }
  return false;
}

bool Constraint::doSimplifications(ArithmeticKB* kb)
{
  CALL("Constraint::doSimplifications");

  if(!_inequality) {
    if(_pol.size()==1 && _pol[0].coef!=0) {
      _pol[0].coef=1;
      return true;
    }
  }

  return false;
}
#endif
}
}
