
/*
 * File Constraint.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __Constraint__
#define __Constraint__

#include "Forwards.hpp"

#include "Lib/Allocator.hpp"

#include "Polynomial.hpp"

namespace Kernel {
namespace Algebra {

#if 0
using namespace Lib;

class Constraint {

  static bool isConstraint(Literal* l);

  Constraint(Literal* lit, bool negate=false);

  CLASS_NAME(Constraint);
  USE_ALLOCATOR(Constraint);

  bool simplify();


 
  bool inequality() const  {return _inequality; }

 
  bool nonEquality() const  {return _negative && !_inequality; }

 
  bool strictInequality() const  {return !_negative && _inequality; }

 
  bool integerInequality() const  { ASS(!_integer || _inequality); return _integer; }

 
  bool simplified() const { return _simplified; }

private:

  bool doSimplifications(ArithmeticKB* kb=0);

  bool _inequality;
  bool _negative;
  bool _integer;

  bool _simplified;

  Polynomial _pol;
};
#endif

}
}

#endif 
