
/*
 * File FormulaUnit.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __FormulaUnit__
#define __FormulaUnit__

#include "Lib/Allocator.hpp"

#include "Unit.hpp"

using namespace std;
using namespace Lib;

namespace Kernel {

class Formula;

class FormulaUnit
  : public Unit
{
public:
 
  FormulaUnit(Formula* f,Inference* inf,InputType it)
    : Unit(FORMULA,inf,it),
      _formula(f)
  {}

  void destroy();
  string toString() const;

  unsigned varCnt();

 
  const Formula* formula() const
  { return _formula; }
 
  Formula* formula()
  { return _formula; }


  Color getColor();

  CLASS_NAME(FormulaUnit);
  USE_ALLOCATOR(FormulaUnit);

protected:
 
  Formula* _formula;
}; 


}
#endif
