
/*
 * File MLMatcher.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */



#ifndef __MLMatcher__
#define __MLMatcher__

#include "Forwards.hpp"

namespace Kernel {

using namespace Lib;

class MLMatcher {
public:
  static bool canBeMatched(Literal** baseLits, unsigned baseLen, Clause* instance, LiteralList** alts,
  	Literal* resolvedLit, bool multiset);
  static bool canBeMatched(Clause* base, Clause* instance, LiteralList** alts,
  	Literal* resolvedLit)
  {
    return canBeMatched(base->literals(), base->length(), instance, alts, resolvedLit, resolvedLit==0);
  }


  static bool canBeMatched(Clause* base, DArray<LiteralList*>& matches);


private:
  template<class T, class U>
  static void orderLiterals(T& base, U& alts,
	  DArray<Literal*>& baseOrd, DArray<LiteralList*>& altsOrd);
};


};

#endif
