
/*
 * File Substitution.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __Substitution__
#define __Substitution__

#include <string>

#include "Lib/DHMap.hpp"
#include "Lib/Environment.hpp"

#include "Term.hpp"

namespace Kernel {

using namespace std;
using namespace Lib;

class Substitution
{
public:
  Substitution() {}

  void bind(int v,Term* t);
  void bind(int v,TermList t);
  bool findBinding(int var, TermList& res) const;
  TermList apply(unsigned var);
  void unbind(int var);
  void reset();
#if VDEBUG
  string toString() const;
#endif
private:
  DHMap<unsigned,TermList> _map;
}; 


}

#endif 

