
/*
 * File Event.cpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#include "Event.hpp"

using namespace Lib;

SubscriptionObject::~SubscriptionObject()
{
  if(hs!=0) {
    hs->sObj=0;
  }
}

void SubscriptionObject::unsubscribe()
{
  if(hs!=0) {
    event->unsubscribe(hs);
    ASS(hs==0);
  }
}

bool SubscriptionObject::belongsTo(BaseEvent& evt)
{
  return &evt==event;
}


SubscriptionData BaseEvent::subscribe(HandlerStruct* h)
{
  HandlerList::push(h, _handlers);
  SubscriptionObject* res=new SubscriptionObject(this, h);
  h->sObj=res;
  return SubscriptionData(res);
}

void BaseEvent::unsubscribe(HandlerStruct* h)
{
  ASS(_handlers->member(h));
  _handlers = _handlers->remove(h);
  if(h->sObj) {
    h->sObj->hs=0;
  }
  delete h;
}
