
/*
 * File IntegerSet.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __IntegerSet__
#define __IntegerSet__

#define BITS_PER_INT (8*sizeof(unsigned int))

namespace Lib {

class IntegerSet
{
public:
  IntegerSet() : _words(0), _set(0) {}
  ~IntegerSet();
  void insert(int n);
  void remove(int n);
  bool member(int n) const;
private:
 
  int _words;
 
  unsigned int* _set;
}; 

} 

#endif
