
/*
 * File Reflection.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */



#ifndef __Reflection__
#define __Reflection__












#define DECL_ELEMENT_TYPE(...) typedef __VA_ARGS__ _ElementType

#define ELEMENT_TYPE(Cl) typename Lib::ElementTypeInfo<Cl>::Type

#define OWN_ELEMENT_TYPE _ElementType

#define DECL_RETURN_TYPE(...) typedef __VA_ARGS__ _ReturnType

#define RETURN_TYPE(Cl) typename Cl::_ReturnType

#define OWN_RETURN_TYPE _ReturnType


#define DECL_ITERATOR_TYPE(...) typedef __VA_ARGS__ _IteratorType

#define ITERATOR_TYPE(Cl) typename Lib::IteratorTypeInfo<Cl>::Type

#define OWN_ITERATOR_TYPE _IteratorType

namespace Lib {

template<typename T>
struct ElementTypeInfo
{
  typedef typename T::_ElementType Type;
};

template<typename T>
struct ElementTypeInfo<T[]>
{
  typedef T Type;
};

template<typename T>
struct ElementTypeInfo<T*>
{
  typedef T Type;
};

template<typename T>
struct IteratorTypeInfo
{
  typedef typename T::_IteratorType Type;
};

template<typename T>
struct IteratorTypeInfo<T const>
{
  typedef typename IteratorTypeInfo<T>::Type Type;
};


};



#endif
