
/*
 * File SWBSplitter.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __SWBSplitter__
#define __SWBSplitter__

#include <utility>

#include "Forwards.hpp"

#include "Splitter.hpp"

#define REPORT_SPLITS 0

namespace Saturation {

using namespace Lib;
using namespace Kernel;
using namespace Indexing;

class SWBSplitter : public Splitter
{
public:
  bool doSplitting(Clause* cl);
protected:
 
  virtual void buildAndInsertComponents(Clause* cl, const CompRec* comps,
      unsigned compCnt, bool firstIsMaster) = 0;

 
  virtual bool handleNoSplit(Clause* cl) { return false; }

  virtual bool canSplitOut(Literal* lit);
};

}

#endif 
