
/*
 * File ForkingCM.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __ForkingCM__
#define __ForkingCM__

#include "Forwards.hpp"

#include "Lib/Portability.hpp"
#include "Lib/ScopedPtr.hpp"

#include "Kernel/Problem.hpp"

#include "CASCMode.hpp"

namespace Shell
{
namespace CASC
{

using namespace Lib;
using namespace Kernel;

#if COMPILER_MSVC

class ForkingCM
: public CASCMode
{
  ForkingCM() { INVALID_OPERATION("Forking CASC mode is not supported on the Windows platform."); }
  bool runSlice(Options& opt) { ASSERTION_VIOLATION; }
};

#else

class ForkingCM
: public CASCMode
{
public:
  ForkingCM();

protected:
  bool runSlice(Options& opt);
  void childRun(Options& opt) NO_RETURN;

private:
  ScopedPtr<Problem> _prb;
};

#endif

}
}

#endif 
