
/*
 * File Flattening.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __Flattening__
#define __Flattening__

#include "Forwards.hpp"

#include "Kernel/Formula.hpp"

namespace Shell {

using namespace Kernel;

class Flattening
{
public:
  static FormulaUnit* flatten (FormulaUnit*);
  static Formula* flatten (Formula*);

  static Formula* getFlattennedNegation(Formula* f);
private:
  static FormulaList* flatten (FormulaList*,Connective con);
}; 

class TopLevelFlatten
{
public:
  bool apply(Problem& prb);
  bool apply(UnitList*& units);
  bool apply(FormulaUnit* fu, Stack<FormulaUnit*>& acc);
};

}

#endif
