
/*
 * File Naming.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __Naming__
#define __Naming__

#include "Kernel/Formula.hpp"
#include "Kernel/Unit.hpp"

using namespace Kernel;

namespace Shell {

class Naming
{
public:
  Naming (int threshold, bool preserveEpr);
  FormulaUnit* apply(FormulaUnit* unit,UnitList*& defs);
private:
 
  enum Where {
   
    ON_TOP,
   
    UNDER_IFF,
   
    OTHER
  }; 
 
  int _threshold;
 
  bool _preserveEpr;

 
  bool _varsInScope;

  bool canBeInDefinition(Formula* f,Where where);

 
  UnitList* _defs;

  Formula* apply(Formula* subformula,Where where,int& pos,int& neg);
  FormulaList* apply(FormulaList* subformulas,
		     Where where,
		     int* results,
		     int* resultsNeg);
  Formula* introduceDefinition(Formula* f,bool iff);

  Literal* getDefinitionLiteral(Formula* f, Formula::VarList* freeVars);
}; 

}

#endif
