
/*
 * File VarManager.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-J6. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-J6 only because so is required by the CASC-J6
 * rules, and for no other reason.
 */


#ifndef __VarManager__
#define __VarManager__

#include <string>

#include "Forwards.hpp"

namespace Shell {

using namespace std;
using namespace Lib;

class VarManager {
public:
  struct VarFactory
  {
    virtual unsigned getVarAlias(unsigned var) = 0;
    virtual string getVarName(unsigned var) = 0;
  };

  static bool varNamePreserving() { return _fact; }
  static void setVarNamePreserving(VarFactory* f) { _fact = f; }
  static VarFactory* varNamePreservingFactory() { return _fact; }

  static unsigned getVarAlias(unsigned var);
  static string getVarName(unsigned var);
private:
  static VarFactory* _fact;
};

}

#endif 
